#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> a;
vector<bool> inv;
vector<int> h;
set<pair<int, int>> q;

void bfs() {
    while (!q.empty()) {
        int x = -q.begin()->first, i = q.begin()->second;
        q.erase(q.begin());
        for (auto j : a[i]) {
            inv[j] = true;
            if (h[j] < x - 1) {
                q.erase({h[j], j});
                if (x - 1 > 0) q.insert({-(x - 1), j});
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    a.resize(n);
    inv.resize(n);
    h.resize(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    for (int i = 0; i < k; ++i) {
        int x, t;
        cin >> x >> t;
        x--;
        q.insert({-t, x});
        h[x] = t;
        inv[x] = true;
    }
    bfs();
    queue<int> ans;
    for (int i = 0; i < n; ++i) {
        if (inv[i]) {
            ans.push(i + 1);
        }
    }
    cout << ans.size() << '\n';
    while (!ans.empty()) {
        cout << ans.front() << ' ';
        ans.pop();
    }
    return 0;
}

