#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> a;
vector<bool> inv;
queue<pair<int, int>> q;

void bfs() {
    while (!q.empty()) {
        int i = q.front().first, h = q.front().second;
        q.pop();
        for (auto j : a[i]) {
            if (!inv[j]) {
                inv[j] = true;
                if (h - 1 > 0) {
                    q.emplace(j, h - 1);
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    a.resize(n);
    inv.resize(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        q.emplace(x, y);
        inv[x] = true;
    }
    bfs();
    queue<int> ans;
    for (int i = 0; i < n; ++i) {
        if (inv[i]) {
            ans.push(i + 1);
        }
    }
    if(!ans.empty()) cout << ans.size() << '\n';
    while (!ans.empty()) {
        cout << ans.front() << ' ';
        ans.pop();
    }
    return 0;
}

